#include <stdio.h>
#include <stdlib.h>

#define physicalSize  100
int array[physicalSize];
int nElements = 0;

int positionValidRead(int position, int nElements){
  if (position >= 0 && position < nElements) return 1;
  else return 0;
}

int positionValidWrite(int position, int nElements){
  if (position >= 0 && position <= nElements
      && position < physicalSize) return 1;
  else return 0;
}

int writeAtEnd(int position, int nElements){
   return( position == nElements);
}

void shiftForward(int position){
    int i;
    for(i= nElements; i== position; i--){
        array[i] = array[i-1];
    }
}

void shiftBackward(int position){
    int i;
    for(i= nElements; i== position; i--){
        array[i-1] = array[i];
    }
}

void write(int position, int value){
    if(positionValidWrite(position, nElements)){
        array[position]= value;
        if (writeAtEnd(position,nElements)) nElements++;
    }
    else printf("Error in write, %d out of bounds\n", position);

}
void insert(int position, int value){
    if(positionValidWrite(position, nElements)){
        shiftForward(position);
        array[position] = value;
        nElements++;
    }
    else printf("Error in insert, %d out of bounds\n", position);
}
int read(int position){
    if(positionValidRead(position, nElements)){
        return array[position];
    }
    else printf("Error in read, %d out of bounds\n", position);

}
int readCancel(int position){
    int result;
    if(positionValidRead(position, nElements)){
        result = array[position];
        shiftBackward(position);
        nElements--;
        return result;
    }
    else printf("Error in read, %d out of bounds\n", position);

}

void print(void){
  int i;
  printf("-------------container array\n");
  for(i=0;  i<nElements; i++)
     printf("element in position %d: %d\n", i, array[i]);
}

int main()
{
    print();
    write (0, 27);  /* here logical size of container is 1 (physical 5) */
    write(1, 44);  /* position 1 contains 44  */
    write(1, -43);  /*  position 1 contains -43, 44 is lost */
    write(3, 88);
    print();
    insert(1, 65); /* position 1 contains 65, 44 is now in position 2 */
    write(2, 55);
    write(3, 33);

    write(66, 76);
    int r = read (1);   /* r == 65 */
    r = read(6); /*  not defined, not allowed, error*/
    r =readCancel(2);   /* r == 55  */
    print();

    return 0;
}
